/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: Conversion.c /main/9 1995/07/14 10:55:54 drk $"
#endif
#endif
#include "testlib.h"

/*************************************************************************
*									 *
*	Name:		CommonCsToRs()					 *
*									 *
*	Function:	This function will receive as input a Compound   *
*			string and return to the user a Regular string   *
*			representation.					 *
*									 *
*	Returns:	A Regular string corresponding to the inputs     *
*			Compound String. Will return NULL if inputted    *
*			string is NULL					 *
*									 *
*************************************************************************/

char *CommonCsToRs(XmString cs)

{
    XmStringContext 	context;
    XmStringCharSet 	charset;
    XmStringDirection 	direction;
    Boolean 		separator;
    char 		*primitive_string;

    /* Don't do conversion if string is NULL */

    if (cs == NULL)
	return (NULL);

    XmStringInitContext(&context,cs);
    XmStringGetNextSegment(context,&primitive_string,
           &charset,&direction,&separator);
    XmStringFreeContext(context);
    return(primitive_string);
}
