/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: GetEdgeCode.c /main/7 1995/07/14 11:33:58 drk $"
#endif
#endif
/***********************************************************************
  	@(#)GetEdgeCode.c	1.3.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/24/90 SJS add to sccs
	Calls:

	Summary:
            Return either TopEdge, BottomEdge, LeftEdge, or RightEdge to
        satisfy the definition of xisInform.edge_code (see xislib.h).  This
        field refers to the edge of the rectangular object that caused a
        pointer Enter or Leave event to occur.

        INPUTS:
            object - pointer to object record
            old_x
            old_y
            new_x
            new_y

        OUTPUTS:
            none

        RETURNS:
            TopEdge, BottomEdge, LeftEdge, or RightEdge
************************************************************************/
#include "xislib.h"

int xisGetEdgeCode(object,old_x,old_y,new_x,new_y)
XisObjectRecord *object;
int old_x,old_y;
int new_x,new_y;
{
    int itmp;

    if ( (old_x < object->x && new_x >= object->x)||
         (old_x >= object->x && new_x < object->x)  )
        return LeftEdge;

    else if ( (old_x >= (itmp = object->x + object->width) && new_x < itmp) ||
              (old_x < itmp && new_x >= itmp) )
        return RightEdge;

    else if ( (old_y < object->y && new_y >= object->y) ||
              (old_y >= object->y && new_y < object->y)   )
        return TopEdge;

    else if ( (old_y >= (itmp = object->y + object->width) && new_y < itmp) ||
              (old_y < itmp && new_y >= itmp) )
        return BottomEdge;

    else
        return UndefinedEdge;

} /* End xisGetEdgeCode() */
