/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: CreateWidget.c /main/7 1995/07/14 11:38:03 drk $"
#endif
#endif
/***********************************************************************
  	@(#)CreateWidget.c	1.3.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/30/90 SJS add to sccs
	Calls:

	Summary:
            Call all InformExpectedAction functions associated with an
        expose event.

        INPUTS
            widget - the widget (assumed already created but not realized)

        OUTPUTS
            none

        RETURNS 
            nothing
************************************************************************/

#include <AutoMessages.h>
#include "xislib.h"

void xisCreateWidget(widget)
Widget widget;
{
    XisObjectRecord *object;
    XisObjectRecord *current_object;

    object = (XisObjectRecord *)NULL;

    xisProcessObjects();

    object = xisFindObjectFromWidget(widget);
    if (object == NULL_Object)
      AutoMessage(_AutoMessages[WARNMSG94]);

    /* Call all relavent InformExpectedActions functions for EventExpose */
  
    current_object = object;
    xisInform.is_valid = 1;
    xisInform.action_obj = object;
    xisInform.pointer_obj = NULL;
    xisInform.modifier_key_status = 0;
    xisInform.button_num = 0;
    xisInform.key_code = 0;
    xisInform.num_clicks = 0;
    xisInform.edge_code = 0;
    xisInform.event_code = EventExpose;

    while (current_object != NULL) {

        if (current_object->proc_InformExpectedActions != NULL) {
            xisInform.current_obj = current_object;
            (*current_object->proc_InformExpectedActions)(EventExpose); 
        }
        current_object = current_object->parent;
    }

    xisInform.is_valid = 0;

} /* End xisCreateWidget() */
