/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: ProcesObjcts.c /main/7 1995/07/14 11:42:18 drk $"
#endif
#endif
/***********************************************************************
  	@(#)ProcesObjcts.c	1.6.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/30/90 SJS add to sccs
            08/28/90 SJS free child_windows initially allocated by XQueryTree()
	Calls:

	Summary:
            Regenerate the graphical objects data structure.

        INPUTS
            none

        OUTPUTS
            none

        RETURNS
            nothing
************************************************************************/

#include "xislib.h"

void xisProcessObjects()
{
    static char routine_name[] = "xisProcessObjects";
    int i;

    xisUseSessionInfo(routine_name);

    /* First free all objects below the root one */

    for (i=0; i<xisMaxObjectNum; i++) {
        if(xisObjects[i].id.num_children)
            XFree( (caddr_t)xisObjects[i].id.children_windows);
        xisObjects[i].in_use = 0;
    }

    xisObjects[0].first_child = NULL_Object;
    xisObjects[0].in_use = TRUE;
    xisMaxObjectNum = 1;

    xisObjects[0].id.window_under_parent = xisRootWindow;
    xisObjects[0].id.window = xisRootWindow;
    xisObjects[0].id.widget = NULL;

    XQueryTree(xisDisplay,xisObjects[0].id.window,
               &xisObjects[0].id.root_window,
               &xisObjects[0].id.parent_window,
               &xisObjects[0].id.children_windows,
               &xisObjects[0].id.num_children);

    /* Then call function to re-generate all the objects */

    (*xisGenerateObjects)(&xisObjects[0]);    

} /* End xisProcessObjects() */
