/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: DumpHier.c /main/9 1995/07/14 11:58:44 drk $"
#endif
#endif

#include "testlib.h"
#include <X11/IntrinsicP.h>

void DumpHierarchy(Widget w, FILE *file, int space);

/*************************************************************************
*									 *
*	Name:		CommonDumpHierarchy()				 *
*									 *
*	Function:	This function will take a widget, and a FILE   	 *
*			pointer to indicate where to write the output.	 *
*			The function will print out all widgets names    *
*			underneath that widget.			 	 *
*									 *
*	Returns:	Nothing						 *
*									 *
*									 *
*************************************************************************/

void CommonDumpHierarchy(Widget w, FILE *file)

{
	DumpHierarchy(w, file, 0);
}


void DumpHierarchy(Widget w, FILE *file, int space)

{
	int		i, j;
	CompositeWidget	cw;

	for (j = 0 ; j < space ; j++)
		fprintf(file, " ");

	if (XtIsComposite(w))
	{
		cw = (CompositeWidget)w;
		fprintf(file, "%s(parent)\n",XtName((Widget)cw));
		for(i = 0; i < cw->composite.num_children; i++)
		{
			DumpHierarchy(cw->composite.children[i], file, 
				      (space + 2));
		}
	}
	else
	{
		fprintf(file, "%s(leaf)\n",XtName(w));
	}

}
