/* $XConsortium: alloc.c /main/5 1995/07/15 21:01:19 drk $ */
/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 */


/*
 *This file contains a front end to malloc.  The function tcMalloc behaves
 *like malloc, but keeps a record.  Calling tcFreeAll will free all memory
 *allocated by tcMalloc
 */
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>

#define MALLOC_CHUNK 50

static void **entriesMalloced;
static int numEntriesMalloced=0;
static int numEntriesAvail=0;


void *
tcMalloc(size_t size)
{
    if (numEntriesMalloced == numEntriesAvail)
    {
	if (numEntriesAvail == 0)
	{
	    numEntriesAvail = MALLOC_CHUNK;
	    entriesMalloced = (void **) XtMalloc(MALLOC_CHUNK * sizeof(void *));
	}
	else
	{
	    numEntriesAvail += MALLOC_CHUNK;
	    entriesMalloced = (void **) XtRealloc((char *) entriesMalloced,
						  numEntriesAvail * sizeof(void *));
	}
    }
    entriesMalloced[numEntriesMalloced] = (void *)XtMalloc(size);
    return (entriesMalloced[numEntriesMalloced++]);
} 

void
tcFreeAll()
{
    while (numEntriesMalloced > 0)
	XtFree(entriesMalloced[--numEntriesMalloced]);
}
