/* $XConsortium: CSTextEnter.c /main/5 1996/06/11 17:25:26 pascale $ */
/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 */

/*  Standard C headers  */
#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>

/*  X headers  */
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>

#include <testlib.h>

#define	NUM_COLUMNS		80
#define	NUM_ROWS		30
#define	MAX_LINE_LEN	255
#define	MAX_NAME_LEN	255

#define	TEXT1_X		10
#define	TEXT1_Y		10

static void 	PrintLapseTime();

/*  Global Variables  */

char infile_name[MAX_NAME_LEN + 1];
char *text_string;
char *small_text_string = "SMALL TEXT";
XmString comp_string;

Widget Form1;
Widget Text;

int	total_lines = 0;
Boolean use_word_wrap = False;
Boolean regular_text = False;

static char font_name1[] = "9x15"; 
static char render_tag[] = "Render1";

XmFontList	newfontlist;
XFontStruct	*newfont;

Arg args[MAX_ARGS];
int n;

main (argc, argv)
int argc;
char **argv;
{
    
    Widget	quit;
    char        name[80];
    XmRenderTable   renderTable = (XmRenderTable)0;
    XmRendition	rendition;
    
    infile_name[0] = '\0';
    
    /*  initialize toolkit  */
    CommonTestInit(argc, argv);

    if (UserData != NULL)
	ProcessCommandArgs();

    n = 0;
    XtSetArg(args[n], XtNwidth, 800);  n++;
    XtSetArg(args[n], XtNheight, 500);  n++;
    XtSetValues(Shell1, args, n);

    XtRealizeWidget(Shell1);
    
    /* create main form */
    n = 0;
    Form1 = XmCreateForm (Shell1, "Form1", args, n);
    XtManageChild (Form1);

    /*
     *  Create XmString using text from buffer.
     */
    comp_string = XmStringCreateLtoR( text_string,
				     XmFONTLIST_DEFAULT_TAG );

    /*
     *  Create renderTable to assign fonts for XmCSText widget.
     */
    if (regular_text == False) {
	n = 0;
	XtSetArg( args[n], XmNfontName, font_name1 ); n++;
	XtSetArg( args[n], XmNfontType, XmFONT_IS_FONT ); n++;
	XtSetArg(args[n], XmNloadModel, XmLOAD_IMMEDIATE );  n++;
	rendition = XmRenditionCreate( Form1, render_tag, args, n );

	renderTable = XmRenderTableAddRenditions( renderTable, &rendition, 1,
					     XmMERGE_REPLACE );

	XmRenditionFree( rendition );
    }
 
    /* create multi line XmCSText widget */
    n = 0;
    XtSetArg(args[n], XmNx, TEXT1_X); n++;
    XtSetArg(args[n], XmNcolumns, NUM_COLUMNS);  n++;
    XtSetArg(args[n], XmNrows, NUM_ROWS);  n++;
    XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT); n++;
    XtSetArg(args[n], XmNscrollHorizontal, False); n++;
    XtSetArg(args[n], XmNeditable, True); n++;
    if (regular_text == False) {
	XtSetArg(args[n], XmNrenderTable, renderTable); n++;
    }
    if (use_word_wrap == True) {
	XtSetArg(args[n], XmNwordWrap, True); n++;
    }
    if (regular_text == False) {
	Text = XmCreateScrolledCSText(Form1, "Text1", args, n);
    }
    else {
	Text = XmCreateScrolledText(Form1, "Text1", args, n);
    }

    XtManageChild(Text);
    
    XtRealizeWidget(Shell1);
    
    CommonPause();
    CommonPause();
    CommonPause();

    XtAppMainLoop(app_context);
}

#define WORD_LEN    32

ProcessCommandArgs()
{

    char    *user_data;
    char    next_word[WORD_LEN + 1];
    int     num_spaces;
    
    user_data = UserData;
    
    while (*user_data != '\0') {
	
        get_next_word(user_data, next_word, &num_spaces);
        user_data += (strlen(next_word) + num_spaces);
	
        if (strcmp(next_word, "-f") == 0) {
	    
	    get_next_word(user_data, next_word, &num_spaces);
	    user_data += (strlen(next_word) + num_spaces);
	    strcpy(infile_name, next_word);
            continue;
	    
        }		
	if (strcmp(next_word, "-use_word_wrap") == 0) {
	    use_word_wrap = True;
	    continue;
	}	
	if (strcmp(next_word, "-regular_text") == 0) {
	    regular_text = True;
	    continue;
	}

    }

    free(UserData);

}

get_next_word(source, dest, spaces)
char    *source;
char    *dest;
int     *spaces;
{

    int n;
    int space_count;

    space_count = 0;

    while (isspace(*source)) {
        source++;
        space_count++;
    }

    n = 0;
    while (!isspace(*source) && *source != '\0' && n < WORD_LEN) {
        *dest++ = *source++;
        n++;
    }
    *dest = '\0';
    *spaces = space_count;

}
