/* $XConsortium: XmeFocusIsInShell.c /main/4 1995/07/15 21:04:35 drk $ */
/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 */

#ifdef REV_INFO
#ifndef lint
static char rcsid[] = ""
#endif
#endif

#include <testlib.h>
#include <Xm/PushB.h>
#include <Xm/XmosP.h>
#include <Xm/XmP.h>

Widget button, button2, extra_shell;
Display *display;

void
button_callback(w, client_data, cbs)
Widget w;
XtPointer client_data;
XmPushButtonCallbackStruct *cbs;
{
  if (XmeFocusIsInShell(button))
    printf("OK - focus is in button\n");
  else
    printf("ERROR - focus should be in button\n");

  /* make sure that focus is NOT in button2 which is in a
     different widget tree than button */
  if (XmeFocusIsInShell(button2))
    printf("ERROR - focus is in button2\n");
  else
    printf("OK - focus should not be in button2\n");
}

void  main (argc, argv)
int argc;
char **argv;
{
  Boolean            trace = False;
  register int       n;
  Arg                args[MAX_ARGS];
  String             dirname;
  XmString           label_str;

  CommonTestInit(argc, argv);

  n = 0;
  XtSetArg(args[n], XmNwidth,  200);  n++;
  XtSetArg(args[n], XmNheight, 200);  n++;
  XtSetValues(Shell1, args, n);

  XtRealizeWidget(Shell1);

  display = XtDisplay(Shell1);

  /* create a button for the user to push and subsequently check
     the funtion. */
  label_str = XmStringCreateSimple("Push Me");
  button = XtVaCreateManagedWidget("button",xmPushButtonWidgetClass, Shell1,
				   XmNlabelString, label_str,
				   XmNwidth, 100,
				   XmNheight, 100,
				   NULL);
  XmStringFree(label_str);
  XtAddCallback(button, XmNactivateCallback, button_callback, NULL);

  /* Create a second independent shell for this test */
  extra_shell = XtAppCreateShell(NULL,
				 "application_class",
				 applicationShellWidgetClass,
				 display,
				 NULL, 0);

  /* create a button */
  label_str = XmStringCreateSimple("Leave me alone.");
  button2 = XtVaCreateManagedWidget("button2",xmPushButtonWidgetClass,
				    extra_shell,
				    XmNlabelString, label_str,
				    NULL);
  XmStringFree(label_str);
  XtRealizeWidget(extra_shell);
  CommonPause();

  CommonPause();	/* quit */
  XtAppMainLoop(app_context);
  XtDestroyWidget(Shell1);
}
