/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: FileSelect1.c /main/9 1995/07/13 19:18:05 drk $"
#endif
#endif
/*
*  (c) Copyright 1987, 1988, 1989 HEWLETT-PACKARD COMPANY */
#include <testlib.h>

static void	GoneCB();
static void 	OkApplyHelpCB();
Widget    		FileSelectionBox1;

void  main(argc, argv)
    int     argc;
    char  **argv;
{
    register int  	n;
    Arg         	args[MAX_ARGS];
    XmString    	tcs, tcs2;
    Widget		CancelW, filelist;

    CommonTestInit(argc, argv);
    
    n = 0;
    XtSetArg(args[n], XmNwidth,  400);  			n++;
    XtSetArg(args[n], XmNheight, 300);  			n++; 
    XtSetValues(Shell1, args, n);
    
    XtRealizeWidget(Shell1);

    tcs = XmStringCreateSimple(
      "/users/qauser/FS/fourteencharac/fourteencharac/fourteencharac/");

    tcs2 = XmStringCreateSimple("b*");

    n = 0;
    XtSetArg(args[n], XmNdirMask, tcs);  			n++;
    XtSetArg(args[n], XmNdirSpec, NULL); 			n++;
    XtSetArg(args[n], XmNpattern, tcs2);			n++;
    FileSelectionBox1 = XmCreateFileSelectionBox(Shell1,
				    "FileSelectionBox1", args, n);
    XtManageChild(FileSelectionBox1);

    XmStringFree(tcs);
    XmStringFree(tcs2);

    /* change some resources */

    tcs = XmStringLtoRCreate("Look For:", XmSTRING_DEFAULT_CHARSET);

    n = 0;
    XtSetArg(args[n], XmNwidth, 350); 				n++; 
    XtSetArg(args[n], XmNheight, 300); 				n++; 
    XtSetArg(args[n], XmNresizePolicy, XmRESIZE_NONE);	n++;
    XtSetArg(args[n], XmNfilterLabelString, tcs);	n++;
    XtSetValues(FileSelectionBox1, args, n);

    XmStringFree(tcs);

    /* add a callback to the Cancel button to destroy the world */

    CancelW = XmFileSelectionBoxGetChild(FileSelectionBox1,
		      			 XmDIALOG_CANCEL_BUTTON);
    XtAddCallback(CancelW,XmNactivateCallback, GoneCB, NULL);

    CommonPause();
    CommonPause();
    CommonPause();
    CommonPause();
    CommonPause();

    XtAddCallback(FileSelectionBox1, XmNokCallback, OkApplyHelpCB, NULL);
    XtAddCallback(FileSelectionBox1, XmNhelpCallback, OkApplyHelpCB, NULL);
    XtAddCallback(FileSelectionBox1, XmNapplyCallback, OkApplyHelpCB, NULL);

    CommonPause();

/* Test for CR 4269 */
/* This test originally used MallocEnable, MallocLeakInfo and
 * MallocDisable to determine memory leaks.
 */

    n = 0;
    XtSetArg(args[n], XmNinitialResourcesPersistent, False); n++;
    XtSetArg(args[n], XmNallowShellResize, True); n++;
    XtSetValues(Shell1, args, n);

    n = 0;
    XtSetArg(args[n], XmNinitialResourcesPersistent, False); n++;
    XtSetValues(FileSelectionBox1, args, n);

    filelist = XmFileSelectionBoxGetChild(FileSelectionBox1, XmDIALOG_LIST);

    XmListSelectPos(filelist, 1, True);
    XmListDeselectPos(filelist, 1);

    CommonPause();

/* End Test for  CR 4269 */


/* Begin Test for Pir2161 */

    tcs = XmStringCreateSimple("/users/qauser/FS/");

    n = 0;
    XtSetArg(args[n], XmNdirMask, tcs); 		n++;
    XtSetValues(FileSelectionBox1, args, n);

    XmStringFree(tcs);

    CommonPause();

/* End Test for Pir2161 */

/* Test for Pir 4110 */

    n = 0;
    XtSetArg(args[n], XmNkeyboardFocusPolicy, XmPOINTER); 	n++;
    XtSetValues(Shell1, args, n);

/* End Test for Pir 4110 */


    CommonPause();

    XtAppMainLoop(app_context);
}


static void GoneCB(w, client_data, call_data )
    Widget  w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* callback for when user clicks the cancel button */
    
    Widget dad;

    dad = XtParent(w);		/* get parent of cancel button */
    XtDestroyWidget(dad);	/* and parent */
}


static void OkApplyHelpCB(w, client_data, call_data)
    Widget  w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* callback for Ok, Apply, or Help button */

    int reason;

    reason = ((XmFileSelectionBoxCallbackStruct *)call_data)->reason;
    switch (reason) {
	case XmCR_OK:	
			printf("Ok Callback triggered: reason XmCR_OK\n");
			break;
	case XmCR_HELP:	
			printf("Help Callback triggered: reason XmCR_HELP\n");
			break;
	case XmCR_APPLY: 
			printf("Apply Callback triggered: reason XmCR_APPLY\n");
			break;
	default:	printf("Invalid reason\n");
			break;
    }
}
